package csa.util;


import java.io.*;


/**
 */
public class Utility 
{
    public static final String getCurrentStackTrace()
    {
        String s="";
        for (int i=0; i < Thread.currentThread().getStackTrace().length; i++)
        {
            s+=Thread.currentThread().getStackTrace()[i]+"\n";
        }
        return s;
    }

    public static String makeRelative(String path)
    {
        File f = new File("."+File.separator);
        String here = f.getAbsolutePath();
        if (path.indexOf(here.substring(0,here.length()-1)) != -1)
        {
            path = path.substring(path.indexOf(here)+here.length());
        }
        else
        {
            // c:\1\2\3\.
            // c:\1\2\blub\sound.wav

            int len = 1;
            while (here.regionMatches(0, path, 0, len)) len++;
            len -=2;
            if (len <= 1) return path;

            // go back to last File separator, dirs may have the same letters in front
            while ((!(path.substring(len).startsWith(File.separator))) && (len >=1)) len--;

            String rPath = path.substring(len+1);
            String rHere = here.substring(len+1);


            // 3\.
            // blub\sound.wav
            int up = UtilityString.countStrings(rHere, File.separator);
            for (int i=0; i< up; i++)
            {
                rPath = ".."+File.separator+rPath;
            }
            path = rPath;
        }
        return path;
    }

    public static String execute(String command)
    {
        String output="";
        try {
            String line;
            Process p = Runtime.getRuntime().exec(command);
            BufferedReader input = new BufferedReader(new InputStreamReader(p.getInputStream()));
            while ((line = input.readLine()) != null)
            {
                output+=line;
                //System.out.println(line);
            }
            input.close();
        } catch (Exception err) {
            err.printStackTrace();
        }
        return output;
    }



}
