/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jtooly.crypt;

/**
 *
 * @author Malban
 */
public class Playfair {
   static private String KeyWord=new String();
   static private String Key=new String();
   static private char matrix_arr[][]= new char[5][5];

   static public void setKey(String k)
   {
      KeyWord=k.toUpperCase();
      // todo eliminate double chars!
   }

   static public String getKey()
   {
      String retKey="";
      for (int i=0 ; i<5 ;i++)
      {
         for (int j=0 ; j<5 ; j++)
         {
            retKey+=matrix_arr[i][j];
         }
      }
      return retKey;
   }

   static public void keyGen()
   {
      char current;

      Key=KeyWord;

      for ( int i=0 ; i<26 ; i++)
      {
         current=(char)(i+'A');
         if(current=='J')
            continue;
         if (KeyWord.indexOf(""+current) == -1)
            Key=Key+current;
      }
System.out.println(Key);
      matrix();
   }

   static public void setMatrix(char m[][])
   {
      for (int i=0 ; i<5 ;i++)
      {
         for (int j=0 ; j<5 ; j++)
         {
            matrix_arr[i][j]=m[i][j];
         }
      }
   }
   static private void matrix()
   {
      for (int i=0 ; i<5 ;i++)
      {
         for (int j=0 ; j<5 ; j++)
         {
            matrix_arr[i][j]=Key.charAt(i*5+j);
            System.out.printf("%s ",matrix_arr[i][j]);
         }
         System.out.println("\n");
      }
   }

   // todo no doubles to X
   static private String[] divid2Pairs (String Original)
   {
      int size= Original.length();

      if(size%2 != 0)
         size++;

      String x[]= new String[size/2];

      int counter=0;

      for ( int i=0 ; i<size/2 ;i++)
      {
         x[i] = Original.toUpperCase().substring(counter, counter+2);
   //      System.out.println(x[i]);
         counter=counter+2;
      }

      return x;
   }

   static public int[]  getMatrixPosition(char letter)
   {
      int []key=new int[2];

      if ( letter == 'J')
         letter='I';

      for (int i=0 ; i<5 ;i++)
      {
         for (int j=0 ; j<5 ; j++)
         {
            if(matrix_arr[i][j] == letter)
            {
               key[0]=i;
               key[1]=j;
               break;
            }
         }
      }
      return key;
   }

   static public String crypt(String Source)
   {
      String src_arr[] = divid2Pairs(Source);

      String code=new String();

      char one;
      char two;

      int part1[]=new int[2];
      int part2[]=new int[2];

      //start on pair by pair
      for (int i=0 ; i< src_arr.length ;i++ )
      {
         one = src_arr[i].charAt(0);//get first char
         two = src_arr[i].charAt(1);//get second char

         part1 = getMatrixPosition(one);//get position of the first char
         part2 = getMatrixPosition(two);//get position of the second char

         //check for specail casese
         if(part1[0]==part2[0])//same row
         {
            if (part1[1]<4)
               part1[1]++;
            else
               part1[1]=0;

            if(part2[1]<4)
               part2[1]++;
            else
               part2[1]=0;
         }

         else if (part1[1]==part2[1]) //same column
         {
            if (part1[0]<4)
               part1[0]++;
            else
               part1[0]=0;

            if(part2[0]<4)
               part2[0]++;
            else
               part2[0]=0;
         }

         else
         {
            int temp=part1[1];
            part1[1]=part2[1];
            part2[1]=temp;
         }


         code= code + matrix_arr[part1[0]][part1[1]] + matrix_arr[part2[0]][part2[1]];
      }
      System.out.println(code);
      return code;
   }

   static public String decrypt (String code)
   {
      String original=new String();

      String src_arr[]=divid2Pairs(code);

      char one;
      char two;

      int part1[]=new int[2];
      int part2[]=new int[2];


      //start on pair by pair
      for (int i=0 ; i< src_arr.length ;i++ )
      {
         one = src_arr[i].charAt(0);//get first char
         two = src_arr[i].charAt(1);//get second char

         part1 = getMatrixPosition(one);//get position of the first char
         part2 = getMatrixPosition(two);//get position of the second char

         //check for specail casese
         if(part1[0]==part2[0])//same row
         {
            if (part1[1]>0)
               part1[1]--;
            else
               part1[1]=4;

            if(part2[1]>0)
               part2[1]--;
            else
               part2[1]=4;
         }

         else if (part1[1]==part2[1]) //same column
         {
            if (part1[0]>0)
               part1[0]--;
            else
               part1[0]=4;

            if (part2[0]>0)
               part2[0]--;
            else
               part2[0]=4;
         }
         else
         {
            int temp=part1[1];
            part1[1]=part2[1];
            part2[1]=temp;
         }


         original =original + matrix_arr[part1[0]][part1[1]] + matrix_arr[part2[0]][part2[1]];
      }

      // System.out.println(original);
      return original;
   }

}
