/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jtooly.numberhelper;

/**
 *
 * @author Malban
 */
public class AsciiNumber
{
    String value="0";

    AsciiNumber()
    {
    }

    AsciiNumber(int i)
    {
        value = ""+i;
    }
    AsciiNumber(long l)
    {
        value = ""+l;
    }

    AsciiNumber(String s)
    {
        try
        {
            // test if format is ok - otherwise 0
            if(s.length()<5)
                Long.parseLong(s);
            else
                Long.parseLong(s.substring(0,4));
            value = s;
        }catch (Throwable e)
        {

        }
    }

    public long getLong()
    {
        try
        {
            return Long.parseLong(value);
        }catch (Throwable e){}
        return 0;
    }
    public int getInt()
    {
        try
        {
            return Integer.parseInt(value);
        }catch (Throwable e){}
        return 0;
    }

    @Override
    public String toString()
    {
        return value;
    }

    AsciiNumber add(int i)
    {
        return add(new AsciiNumber(i));
    }
    AsciiNumber add(long l)
    {
        return add(new AsciiNumber(l));
    }
    AsciiNumber add(AsciiNumber other)
    {
        String addedString = "";
        String s1;
        String s2;
        if (value.length()>=other.value.length())
        {
            s1 = value;
            s2 = other.value;
        }
        else
        {
            s1 = other.value;
            s2 = value;
        }

        int carry = 0;
        for (int i = 0; i < s1.length();i++)
        {
            String digit1 = "0";
            String digit2 = "0";
            int indexStart1 = s1.length()-(i+1);
            digit1 = s1.substring(indexStart1, indexStart1+1);
            int indexStart2 = s2.length()-(i+1);
            if (indexStart2>=0)
                digit2 = s2.substring(indexStart2, indexStart2+1);

            int iDigit1 = Integer.parseInt(digit1);
            int iDigit2 = Integer.parseInt(digit2);
            int newDigit = iDigit1 + iDigit2 + carry;
            if (newDigit>9)
            {
                carry = 1;
                newDigit -=10;
            }
            else
                carry = 0;
            addedString = newDigit + addedString;
        }
        if (carry==1) addedString = "1" + addedString;
        return new AsciiNumber(addedString);
    }
}
