/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jtooly.numberhelper;

import java.util.HashMap;
import java.util.Vector;

/**
 *
 * @author Malban
 */
public class Int {
    public static int getDigit(long n, int i)
    {
        return getDigit(""+n, i);
    }
    public static int getDigit(String number, int i)
    {
        int idigit = 0;
        try
        {
            String digit = number.substring(i, i + 1);
            idigit = Integer.parseInt(digit);
        }
        catch (Throwable e)
        {
            return -1;
        }
        return idigit;
    }

    public static int getDigitSum(long zahl)
    {
        String sZahl = "" + zahl;
        int sum = 0;
        for (int i = 0; i < sZahl.length(); i++)
        {
            String digit = sZahl.substring(i, i + 1);
            int idigit = Integer.parseInt(digit);
            sum += idigit;
        }
        return sum;
    }
    private static void getDivisorPermutations(long counter, Vector<Integer> d, long[] primes, int pos)
    {
        if (pos >= primes.length) return;

        int w = (int) primes[pos];
        if ((!(d.contains(w))) && (counter!=w)) d.addElement(w);

        while (true)
        {
            boolean added = false;
            for (int i = 0; i < d.size(); i++)
            {
                Integer integer = d.elementAt(i);
                int w2 = integer*w;

                if ((!(d.contains(w2))) && (counter%w2 == 0) && (counter!=w2) )
                {
                    d.addElement(w2);
                    added = true;
                }

            }
            if (!added) break;
        }
        getDivisorPermutations(counter, d, primes, pos+1);
    }

    public static int[] getDivisors(long counter)
    {
        Vector<Integer> d = new Vector<Integer>();
        long[] primess =  PrimeFactors.primeFactors(counter);
        long[] primes = new long[primess.length+1];
        primes[0] = 1;
        for (int i = 0; i < primess.length; i++)
        {
           primes[i+1] = primess[i];
        }
        getDivisorPermutations(counter, d, primes, 0);
        int[] ret= new int[d.size()];
        for (int i = 0; i < d.size(); i++)
        {
            Integer integer = d.elementAt(i);
            ret[i] = integer;
        }
        return ret;
    }

    public static boolean isAnySumEqual(int[] divisors, long counter, long start, int pos)
    {
        boolean ret = false;
//System.out.println(""+counter+": = "+start+"?");
        int me = divisors[pos];
        if (start+me == counter) return true;

        if (pos+1<divisors.length)
            ret = ret || isAnySumEqual(divisors, counter, start, pos+1);
        if (ret) return ret;
        for (int i = pos+1; i < divisors.length; i++)
        {
            ret = ret || isAnySumEqual(divisors, counter, start+me, i);
            if (ret) return ret;
        }

        return ret;
    }
    static HashMap<Long, Long> fibMap = new HashMap<Long, Long> ();
    public static long Fibunacci(long in)
    {
        if (in < 0) return 0;
        if (in <= 0) return 1;
        if (in == 1) return 1;
        Long v = fibMap.get(in);
        if (v != null) return v;

        v = Fibunacci(in -2) + Fibunacci(in -1);
        fibMap.put(in,v);

        return v;
    }
    static HashMap<Long, AsciiNumber> afibMap = new HashMap<Long, AsciiNumber> ();
    public static AsciiNumber AFibunacci(long in)
    {
        if (in < 0) return new AsciiNumber("0");
        if (in <= 0) return new AsciiNumber("1");
        if (in == 1) return new AsciiNumber("1");
        AsciiNumber v = afibMap.get(in);
        if (v != null) return v;


        v = AFibunacci(in -2).add(AFibunacci(in -1));
        afibMap.put(in, v);
        // System.out.println(""+in +" -> " + v);
        return v;
    }


}
